﻿Module Module2

    Public Function CaptureShell(ByVal strProgram As String, ByVal strArguments As String, _
                Optional ByVal intTimeout As Integer = 0, Optional ByVal boolTerminate As Boolean = False) As String

        Dim objProcess As New Process()
        Dim strOutput As String
        Dim strError As String

        Try
            objProcess.StartInfo.UseShellExecute = False
            objProcess.StartInfo.RedirectStandardOutput = True
            objProcess.StartInfo.RedirectStandardInput = True
            objProcess.StartInfo.RedirectStandardError = True
            objProcess.StartInfo.CreateNoWindow = True
            objProcess.StartInfo.FileName() = strProgram
            objProcess.StartInfo.Arguments() = strArguments
            objProcess.Start()

            strOutput = objProcess.StandardOutput.ReadToEnd()
            strError = objProcess.StandardError.ReadToEnd()

            If intTimeout > 0 Then
                objProcess.WaitForExit(intTimeout * 1000)
            End If

            If boolTerminate And Not objProcess.HasExited Then
                objProcess.Kill()
            End If

            objProcess.Close()

            If strOutput <> "" Then
                CaptureShell = strOutput
            Else
                CaptureShell = strError
            End If

        Catch ex As Exception
            CaptureShell = ""
        End Try

    End Function
End Module
